#ifndef DEVIO_H
#define DEVIO_H

//===============================================
#ifndef CTL_CODE

#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)
#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3
#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS				( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS				( 0x0002 )    // file & pipe
#define FILE_DEVICE_UNKNOWN             0x00000022

#endif

//===============================================
#define WINRING_Access		CTL_CODE(		\
			FILE_DEVICE_UNKNOWN,		\
			0x999,				\
			METHOD_BUFFERED,		\
			FILE_ANY_ACCESS)

#endif

class TRingData
{
public:
	ULONG AdjRing0Entry;
	ULONG RegData[7];
};

